/*
 * Software for Interactive Project Pool Game
 * Columbia University. New York, 2008
 * Authors:
 *   Abdulhamid Ghandour
 *   Thomas John
 *   Jaime Peretzman
 *   Bharadwaj Vellore
 * 
 * Desc:
 */
#include <unistd.h>
#include <string.h>
#include "io.h"
#include "system.h"
#include "ui.h"

unsigned long sevensegment[] = {/* Active Low -> xgfedcba */
  0x40,                         /*          0 -> 01000000 */   
  0x79,                         /*          1 -> 01111001 */  
  0x24,                         /*          2 -> 00100100 */
  0x30,                         /*          3 -> 00110000 */
  0x19,                         /*          4 -> 00011001 */   
  0x12,                         /*          5 -> 00010010 */  
  0x02,                         /*          6 -> 00000010 */
  0xF8,                         /*          7 -> 01111000 */
  0x00,                         /*          8 -> 00000000 */
  0x10,                         /*          9 -> 00010000 */
  0x0C                          /*          P -> 00001100 */
};

#define P                      10

void initPointsDisplay(){
  HEX7(sevensegment[P]);
  HEX6(sevensegment[1]);
  HEX3(sevensegment[P]);
  HEX2(sevensegment[2]);
    
  HEX5(sevensegment[0]);
  HEX4(sevensegment[0]);
  HEX1(sevensegment[0]);
  HEX0(sevensegment[0]);
}

void LCD_Init()
{
    lcd_write_cmd(LCD_BASE,0x38);
    usleep(2000);
    lcd_write_cmd(LCD_BASE,0x0C);
    usleep(2000);
    lcd_write_cmd(LCD_BASE,0x01);
    usleep(2000);
    lcd_write_cmd(LCD_BASE,0x06);
    usleep(2000);
    lcd_write_cmd(LCD_BASE,0x80);
    usleep(2000);
}

void LCD_Show_Text(char* Text)
{
    int i;
    for (i=0;i<strlen(Text);i++) {
        lcd_write_data(LCD_BASE,Text[i]);
        usleep(2000);
    }
}

void LCD_Line2()
{
    lcd_write_cmd(LCD_BASE,0xC0);
    usleep(2000);
}


